package com.rjconsultores.ventaboletos.service.impl;

import java.util.Calendar;
import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.rjconsultores.ventaboletos.dao.ItemAdicionalDAO;
import com.rjconsultores.ventaboletos.entidad.ItemAdicional;
import com.rjconsultores.ventaboletos.entidad.Pacote;
import com.rjconsultores.ventaboletos.service.ItemAdicionalService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;

@Service("itemAdicionalService")
public class ItemAdicionalServiceImpl implements ItemAdicionalService {

	@Autowired
	private ItemAdicionalDAO itemAdicionalDAO;

	@Override
	public List<ItemAdicional> obtenerTodos() {
		return itemAdicionalDAO.obtenerTodos();
	}

	@Override
	public ItemAdicional obtenerID(Integer id) {
		return itemAdicionalDAO.obtenerID(id);
	}

	@Transactional
	@Override
	public ItemAdicional suscribir(ItemAdicional entidad) {
		entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
		entidad.setFecmodif(Calendar.getInstance().getTime());
		entidad.setActivo(Boolean.TRUE);

		return itemAdicionalDAO.suscribir(entidad);
	}

	@Transactional
	@Override
	public ItemAdicional actualizacion(ItemAdicional entidad) {
		entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
		entidad.setFecmodif(Calendar.getInstance().getTime());
		entidad.setActivo(Boolean.TRUE);

		return itemAdicionalDAO.actualizacion(entidad);
	}

	@Transactional
	@Override
	public void borrar(ItemAdicional entidad) {
		entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
		entidad.setFecmodif(Calendar.getInstance().getTime());
		entidad.setActivo(Boolean.FALSE);

		itemAdicionalDAO.actualizacion(entidad);
	}

	@Override
	public List<ItemAdicional> buscaItemAdicionalPacote(Pacote pacote) {
		return itemAdicionalDAO.buscaItemAdicionalPacote(pacote);
	}
}
